package com.zhongzheng.modules.user.service;

import com.zhongzheng.modules.user.domain.UserPlan;
import com.zhongzheng.modules.user.vo.CalendarStudyVo;
import com.zhongzheng.modules.user.vo.UserPlanVo;
import com.zhongzheng.modules.user.bo.UserPlanQueryBo;
import com.zhongzheng.modules.user.bo.UserPlanAddBo;
import com.zhongzheng.modules.user.bo.UserPlanEditBo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.text.ParseException;
import java.util.Collection;
import java.util.List;

/**
 * 【请填写功能名称】Service接口
 *
 * @author ruoyi
 * @date 2021-06-24
 */
public interface IUserPlanService extends IService<UserPlan> {
	/**
	 * 查询单个
	 * @return
	 */
	UserPlanVo queryById(Long userId);

	/**
	 * 查询列表
	 */
	List<UserPlanVo> queryList(UserPlanQueryBo bo);

	/**
	 * 根据新增业务对象插入【请填写功能名称】
	 * @param bo 【请填写功能名称】新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(UserPlanAddBo bo);

	/**
	 * 根据编辑业务对象修改【请填写功能名称】
	 * @param bo 【请填写功能名称】编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserPlanEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);


	/**
	 * 校验并删除数据
	 * @param bo
	 * @return
	 */
	UserPlanVo generate(UserPlanQueryBo bo) throws ParseException;

	List<UserPlanVo> userPlan(UserPlanQueryBo bo);

	Boolean updateGenerate(UserPlanAddBo bo) throws ParseException;

	UserPlanVo userPlanSeven(UserPlanQueryBo bo);

	boolean editPlan(UserPlanQueryBo bo) throws ParseException;
}
